
module SamFront

  class Base
    @forward = false
    @name    = nil
    @next    = nil

    def initialize
      @name = self.class.to_s
    end

    def forward _next
      @next = _next
      @forward = true
    end

    def set_config conf
      raise "Not a valid conf for #{@name}" unless conf.is_a? Hash
    end

    def task data
    end

    def run_task data
      data = task(data)
      #@next.run_task(data) if @forward
      if @forward
        puts "Running next: #{@next.class.to_s}"
        @next.run_task(data)
      end
    end

  end

end